#[macro_use]
extern crate bitflags;
extern crate cairo;
extern crate cairo_sys;
extern crate gdk;
extern crate gio;
extern crate glib;
extern crate glib_sys;
extern crate gtk;
extern crate gtk_sys;
#[allow(unused_imports)]
#[macro_use] // only for tests
extern crate maplit;
extern crate serde;
extern crate xkbcommon;
extern crate zbus;
extern crate zvariant;

#[cfg(test)]
#[macro_use]
mod assert_matches;
#[macro_use]
mod logging;

mod action;
pub mod actors;
mod animation;
pub mod data;
mod drawing;
mod event_loop;
pub mod float_ord;
pub mod imservice;
mod keyboard;
pub mod keycodes;
mod layout;
mod locale;
mod main;
mod outputs;
mod panel;
mod popover;
mod receiver;
pub mod resources;
mod state;
mod style;
mod submission;
pub mod tests;
pub mod util;
mod vkeyboard;
mod xdg;
